//---- Modified Bettle Bug.............. Miller 7/14/92
//#include "colors.inc"
//#include "shapes.inc"
//#include "textures.inc"
//
//  Original file by Mike Miller
//
//  Modified for POV-Ray version 3.x by
//  Colin Fleming, cj_fleming@btinternet.com
//

//----- Bug Legs
#declare YourTexture =
texture {
  pigment { color rgb 0 }
  finish { ambient 0.1 diffuse 0.6 phong 1 phong_size 80 }
}

#declare Dot =
sphere { 0, 1 }

#declare Connector_1 =
object {
  quadric { <0, 1, 1>, 0, 0, -1 }
  clipped_by {
    plane { x, 1 }
    plane { -x, 0 }
  }
}

#declare Connector_2 =
quadric { <1, -1, 1>, 0, 0, 0 rotate z*90 }

/*----------------------------------------------------------------------------*/

#declare YourThing1 =
   union {
      sphere { 0, 0.5 translate <-34, 0, 17> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.899684 }
            plane { x, 0.499825 inverse }
         }
         translate x*-0.499825
         scale <37.735925, 1, 1>
         translate x*0.013245
         rotate z*15.361395
         rotate y*15.945396
         translate <-34, 0, 17>
         texture { YourTexture }
      }
      sphere { 0, 0.9 translate <-20, 4, 13> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.858545 }
            plane { x, 0.572364 inverse }
         }
         translate x*-0.858545
         scale <3.179797, 1, 1>
         translate x*-0.27
         rotate y*180
         translate <-20, 4, 13>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <-19, 4, 13> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.899236 }
            plane { x, 0.599490 inverse }
         }
         translate x*-0.59949
         scale <24.24642, 1, 1>
         translate x*0.024725
         rotate z*55.503763
         rotate y*-14.036243
         translate <-19, 4, 13>
         texture { YourTexture }
      }
      sphere { 0, 0.9 translate <-15, 10, 14> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.858545 }
            plane { x, 0.572364 inverse }
         }
         translate x*-0.858545
         scale <3.179797, 1, 1>
         translate x*-0.27
         rotate y*180
         translate <-15, 10, 14>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <-14, 10, 14> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 1.984748 }
            plane { x, 0.595424 inverse }
         }
         translate x*-0.595424
         scale <8.050859, 1, 1>
         translate x*0.073958
         rotate z*20.620734
         rotate y*41.185925
         translate <-14, 10, 14>
         texture { YourTexture }
      }
      sphere { 0, 2 translate <-6, 14, 7> texture { YourTexture } }
      object {
         Connector_1
         scale <14, 2, 2>
         rotate y*90
         translate <-6, 14, 7>
         texture { YourTexture }
      }
      sphere { 0, 2 translate <-6, 14, -7> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 1.984748 }
            plane { x, 0.595424 inverse }
         }
         translate x*-1.984748
         scale <8.050859, 1, 1>
         translate x*-0.246526
         rotate y*180
         rotate z*-20.620734
         rotate y*138.814075
         translate <-6, 14, -7>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <-14, 10, -14> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.858545 }
            plane { x, 0.572364 inverse }
         }
         translate x*-0.572364
         scale <3.179797, 1, 1>
         translate x*0.18
         rotate y*-180
         translate <-14, 10, -14>
         texture { YourTexture }
      }
      sphere { 0, 0.9 translate <-15  10 -14> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.899236 }
            plane { x, 0.599490 inverse }
         }
         translate x*-0.899236
         scale <24.246420, 1, 1>
         translate x*-0.037087
         rotate y*180
         rotate z*-55.503763
         rotate y*-165.963757
         translate <-15, 10, -14>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <-19, 4, -13> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.858545 }
            plane { x, 0.572364 inverse }
         }
         translate x*-0.572364
         scale <3.179797, 1, 1>
         translate x*0.18
         rotate y*-180
         translate <-19, 4, -13>
         texture { YourTexture }
      }
      sphere { 0, 0.9 translate <-20, 4, -13> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.899684 }
            plane { x, 0.499825 inverse }
         }
         translate x*-0.899684
         scale <37.735925, 1, 1>
         translate x*-0.023842
         rotate y*180
         rotate z*-15.361395
         rotate y*164.054604
         translate <-20, 4, -13>
         texture { YourTexture }
      }
      sphere { 0, 0.5 translate <-34, 0, -17> texture { YourTexture } }
      bounded_by { sphere { 0, 27.098316 translate <-19.25, 7.75, 0> } }
  }

#declare YourThing2 =
union {
      sphere { 0, 0.5 translate <44, 0, 16> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.899762 }
            plane { x, 0.499868 inverse }
         }
         translate x*-0.499868
         scale <43.433858, 1, 1>
         translate x*0.011509
         rotate z*9.940803
         rotate y*-173.290163
         translate <44, 0, 16>
         texture { YourTexture }
      }
      sphere { 0, 0.9 translate <27, 3, 18> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.858545 }
            plane { x, 0.572364 inverse }
         }
         translate x*-0.858545
         scale <3.179797, 1, 1>
         translate x*-0.27
         rotate y*180
         rotate y*-180
         translate <27, 3, 18>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <26, 3, 18> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.999428 }
            plane { x, 0.599657 inverse }
         }
         translate x*-0.599657
         scale <29.563491, 1, 1>
         translate x*0.020284
         rotate z*30.470359
         rotate y*168.690068
         translate <26, 3, 18>
         texture { YourTexture }
      }
      sphere { 0, 1 translate <16, 9, 16> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.916515 }
            plane { x, 0.549909 inverse }
         }
         translate x*-0.916515
         scale <2.291288, 1, 1>
         translate x*-0.4
         rotate y*180
         rotate y*-180
         translate <16, 9, 16>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <15, 9, 16> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 1.497548 }
            plane { x, 0.599019 inverse }
         }
         translate x*-0.599019
         scale <17.469197, 1, 1>
         translate x*0.03429
         rotate z*14.714354
         rotate y*156.801409
         translate <15, 9, 16>
         texture { YourTexture }
      }
      sphere { 0, 1.5 translate <1, 13, 10> texture { YourTexture } }
      object {
         Connector_1
         scale <20, 1.5, 1.5>
         rotate y*90
         translate <1, 13, 10>
         texture { YourTexture }
      }
      sphere { 0, 1.5 translate <1, 13, -10> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 1.497548 }
            plane { x, 0.599019 inverse }
         }
         translate x*-1.497548
         scale <17.469197, 1, 1>
         translate x*-0.085725
         rotate y*180
         rotate z*-14.714354
         rotate y*23.198591
         translate <1  13 -10>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <15, 9, -16> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.916515 }
            plane { x, 0.549909 inverse }
         }
         translate x*-0.549909
         scale <2.291288, 1, 1>
         translate x*0.240000
         translate <15  9 -16>
         texture { YourTexture }
      }
      sphere { 0, 1 translate <16, 9, -16> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.999428 }
            plane { x, 0.599657 inverse }
         }
         translate x*-0.999428
         scale <29.563491, 1, 1>
         translate x*-0.033806
         rotate y*180
         rotate z*-30.470359
         rotate y*11.309932
         translate <16  9 -16>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <26, 3, -18> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.858545 }
            plane { x, 0.572364 inverse }
         }
         translate x*-0.572364
         scale <3.179797, 1, 1>
         translate x*0.18
         translate <26  3 -18>
         texture { YourTexture }
      }
      sphere { 0, 0.9 translate <27, 3, -18> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.899762 }
            plane { x, 0.499868 inverse }
         }
         translate x*-0.899762
         scale <43.433858, 1, 1>
         translate x*-0.020716
         rotate y*180
         rotate z*-9.940803
         rotate y*-6.709837
         translate <27  3 -18>
         texture { YourTexture }
      }
      sphere { 0, 0.5 translate <44, 0, -16> texture { YourTexture } }
      bounded_by { sphere { 0, 33.359393 translate <22, 7, 0> } }
   }

#declare YourThing3 =
    union {
      sphere { 0, 0.5 translate <-15, 0, 20> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.899615 }
            plane { x, 0.499786 inverse }
         }
         translate x*-0.499786
         scale <34.172357, 1, 1>
         translate x*0.014625
         rotate z*12.672721
         rotate y*12.994617
         translate <-15  0  20>
         texture { YourTexture }
      }
      sphere { 0, 0.9 translate <-2, 3, 17> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.858545 }
            plane { x, 0.572364 inverse }
         }
         translate x*-0.858545
         scale <3.179797, 1, 1>
         translate x*-0.27
         rotate y*180
         translate <-2, 3, 17>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <-1, 3, 17> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.899190 }
            plane { x, 0.599460 inverse }
         }
         translate x*-0.59946
         scale <23.549003, 1, 1>
         translate x*0.025456
         rotate z*34.449902
         rotate y*149.036243
         translate <-1, 3, 17>
         texture { YourTexture }
      }
      sphere { 0, 0.9 translate <-6, 7, 14> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.858545 }
            plane { x, 0.572364 inverse }
         }
         translate x*-0.858545
         scale <3.179797, 1, 1>
         translate x*-0.27
         rotate y*180
         rotate y*90
         translate <-6, 7, 14>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <-6, 7, 13> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 1.965313 }
            plane { x, 0.589594 inverse }
         }
         translate x*-0.589594
         scale <5.299211, 1, 1>
         translate x*0.111261
         rotate z*41.472934
         rotate y*45
         translate <-6, 7, 13>
         texture { YourTexture }
      }
      sphere { 0, 2 translate <-2, 12, 9> texture { YourTexture } }
      object {
         Connector_1
         scale <18  2  2>
         rotate y*90
         translate <-2, 12, 9>
         texture { YourTexture }
      }
      sphere { 0, 2 translate <-2, 12, -9> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 1.965313 }
            plane { x, 0.589594 inverse }
         }
         translate x*-1.965313
         scale <5.299211, 1, 1>
         translate x*-0.370869
         rotate y*180
         rotate z*-41.472934
         rotate y*135
         translate <-2, 12, -9>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <-6, 7, -13> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.858545 }
            plane { x, 0.572364 inverse }
         }
         translate x*-0.572364
         scale <3.179797, 1, 1>
         translate x*0.18
         rotate y*90
         translate <-6, 7, -13>
         texture { YourTexture }
      }
      sphere { 0, 0.9 translate <-6, 7, -14> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.899190 }
            plane { x, 0.599460 inverse }
         }
         translate x*-0.89919
         scale <23.549003, 1, 1>
         translate x*-0.038184
         rotate y*180
         rotate z*-34.449902
         rotate y*30.963757
         translate <-6, 7, -14>
         texture { YourTexture }
      }
      sphere { 0, 0.6 translate <-1, 3, -17> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.858545 }
            plane { x, 0.572364 inverse }
         }
         translate x*-0.572364
         scale <3.179797, 1, 1>
         translate x*0.18
         rotate y*180
         translate <-1, 3, -17>
         texture { YourTexture }
      }
      sphere { 0, 0.9 translate <-2, 3, -17> texture { YourTexture } }
      object { Connector_2
         clipped_by {
            plane { x, 0.899615 }
            plane { x, 0.499786 inverse }
         }
         translate x*-0.899615
         scale <34.172357, 1, 1>
         translate x*-0.026326
         rotate y*180
         rotate z*-12.672721
         rotate y*167.005383
         translate <-2, 3, -17>
         texture { YourTexture }
      }
      sphere { 0, 0.5 translate <-15, 0, -20> texture { YourTexture } }
      bounded_by { sphere { 0, 25.392494 translate <-7.75, 6.75, 0> } }
   }

//--- #sets of Legs
#declare Legs =
union {
   object { YourThing1 }
   object { YourThing2 }
   object { YourThing3 }
   bounded_by { sphere { 0, 49.787153 translate <5, 7.75, 0> } }
}

#declare Head_Color =
texture {
   pigment {
      gradient x
      color_map {
         [0.0 0.2 color rgb 0 color DarkGreen]
         [0.2 0.6 color DarkGreen color DarkGreen]
         [0.6 1.0 color DarkGreen color rgb 0]
      }
   }
   finish { ambient 0.2 }
   scale <5, 1, 1>
}
texture {
   pigment { color Gold filter 0.8 }
   normal { bumps 0.2 frequency 0.01 }
   finish { phong 1 phong_size 80 }
}

#declare Chest_Color =
texture {
   pigment {
      bozo
      color_map {
         [0.0 0.2 color rgb 0 color Violet]
         [0.2 0.6 color Violet color DarkGreen]
         [0.6 1.0 color DarkGreen color rgb 0]
      }
   }
   finish { ambient 0.2 }
   scale <2, 1, 1>
}
texture {
   pigment { color Red filter 0.7 }
   normal { ripples 0.5 scale <0.1, 10, 10> }
   finish { phong 1 phong_size 20 }
}

#declare Back_Color =
texture {
   pigment {
      gradient <1 0 0>
      color_map {
         [0.0 0.2 color rgb 0 color Violet]
         [0.2 0.6 color Violet color DarkGreen]
         [0.6 1.0 color DarkGreen color rgb 0]
      }
   }
   finish {
      ambient 0.2
      diffuse 0.3
   }
   scale <5, 1, 1>
}
texture {
   pigment { color Gold filter 0.7 }
   normal { waves 0.5 scale <0.20 10 10> }
   finish { phong 1 phong_size 20}
}

#declare Antler_Color =
texture { pigment { color rgb 0 } finish { ambient 0.2 phong 1 } }

#declare Head =
object {
   union {
      sphere { 0, 1 scale <6.5, 3.5, 6.5> rotate z*23 rotate y*12 translate <-24, 12, -0.1> }
      sphere { 0, 1 scale <6.5, 3.5, 6.5> rotate z*23 rotate y*-12 translate <-24, 12, 0.1> }
      sphere { 0, 1 scale <6, 4, 4> rotate z*30  translate <-23, 13.5, 0> }
   }
   texture { Head_Color }
   bounded_by { sphere { 0, 8.5 translate <-24, 12, 0> } }
}


#declare Chest =
intersection {
   union {
      sphere { 0, 1 scale <6, 6, 8> translate <-17, 17, 0> }
      sphere { 0, 1 scale 6 translate <-12, 19, 3> }
      sphere { 0, 1 scale 6 translate <-12, 19, -3> }
      sphere { 0, 1 scale <8, 4, 6> translate <-12, 16, -3> }
   }
   sphere { 0, 1 scale 8 translate <-27, 11, 0> inverse }
   texture { Chest_Color }
   bounded_by { sphere { 0, 13 translate <-13, 18, 0> }  }
}

#declare Eye =
union {
   sphere { 0, 3 texture { Head_Color } }
   sphere { 0, 2.5 translate z*-2 texture { pigment { rgb 0 } finish { phong 1 phong_size 80 } } }
}

#declare Pincher =
object {
   intersection {
      sphere { 0, 1 scale <6, 0.7, 3> }
      sphere { 0, 1 scale <3.5, 4, 1.6> translate x*-2.5 inverse }
   }
   texture { Head_Color scale 0.3 }
   texture { pigment { color Gold filter 0.4 } }
   bounded_by { sphere {0, 7 } }
}

#declare Back =
union {
   sphere { 0, 1 scale <20, 8, 10> translate <6, 21, -2> }
   sphere { 0, 1 scale <20, 8, 10> translate <6, 21, 2> }
   sphere { 0, 1 scale <20, 8, 10> translate <6, 21, 0> }
   sphere { 0, 1 scale <20, 8, 10> translate <11, 21, 0> }
   sphere { 0, 1 scale <6, 5, 5> translate <26, 20, 0> }
   texture { Back_Color }
   bounded_by { sphere { 0, 1 scale <30, 15, 15> translate <8, 20, 0> } }
}


#declare Antler =
object {
   intersection {
      object { Cylinder_Y scale <10.5, 1, 7.5> }
      object { Cylinder_Y scale <10.5, 1, 7.2> inverse }
      plane { y, 0.2 }
      plane { y, 0 inverse }
      plane { x, -5 inverse }
   }
   texture { Antler_Color }
   bounded_by { sphere { 0, 1 scale <15, 4, 10> } }
}

//--- One complete Bug
#declare Bug =
union {
   object { Head }
   object { Pincher scale <1.4, 1.2, 1.3> rotate z*12 translate <-30, 9, 0> }
   object { Chest }
   object { Eye translate <-24, 14, -3> }
   object { Eye rotate x*180 translate <-24, 14, 3> }
   object { Back }
   object { Antler rotate z*12 translate <-36, 9, 0> }
   object { Legs }
   bounded_by { box { -1, 1 scale <50, 20, 30> translate y*18 } }
}
